
#include-once

; Linalg UDF

; Typen
; V1 = Vektor mit 1 Elementen (Array[1])
; V2 = Vektor mit 2 Elementen (Array[2])
; V3 = Vektor mit 3 Elementen (Array[3])
; V4 = Vektor mit 4 Elementen (Array[4])
; M22 = Matrix mit 2x2 Elementen (Array[2][2])
; M33 = Matrix mit 3x3 Elementen (Array[3][3])
; M44 = Matrix mit 4x4 Elementen (Array[4][4])


; ##### Konstanten #####
Global Const $__LA_PI = 3.1415926535897932
Global Const $__LA_2PI = $__LA_PI * 2.0
Global Const $__LA_PI2 = $__LA_PI / 2.0
Global Const $__LA_3PI = $__LA_PI * 3.0
Global Const $__LA_PI3 = $__LA_PI / 3.0
Global Const $__LA_2PI3 = $__LA_2PI / 3.0
Global Const $__LA_3PI2 = $__LA_PI2 * 3.0
Global Const $__LA_DEG2RAD = $__LA_PI / 180.0
Global Const $__LA_RAD2DEG = 180.0 / $__LA_PI
Global Const $__LA_M33I = [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]]
Global Const $__LA_M33MirrorX = [[-1, 0, 0], [0, 1, 0], [0, 0, 1]]
Global Const $__LA_M33MirrorY = [[1, 0, 0], [0, -1, 0], [0, 0, 1]]
Global Const $__LA_M33MirrorZ = [[1, 0, 0], [0, 1, 0], [0, 0, -1]]
Global Const $__LA_EPS = 1e-9

; Wofr ist der da? was ist $__LA_PRE ?
Global Const $__LA_PRE = [$__LA_M33I, _
	M33DiagXYZ(Sqrt(8), Sqrt(5), Sqrt(3)), M33DiagXYZ(Sqrt(8), Sqrt(3), Sqrt(5)), _
	M33DiagXYZ(Sqrt(5), Sqrt(8), Sqrt(3)), M33DiagXYZ(Sqrt(5), Sqrt(3), Sqrt(8)), _
	M33DiagXYZ(Sqrt(3), Sqrt(8), Sqrt(5)), M33DiagXYZ(Sqrt(3), Sqrt(5), Sqrt(8))]

; ##### Funktionen #####

Func Rad($deg)
	Return $deg * $__LA_DEG2RAD
EndFunc   ;==>Rad

Func Deg($rad)
	Return $rad * $__LA_RAD2DEG
EndFunc   ;==>Deg


; ##### Konstruktoren #####

Func V1($x = 0)
	Local $_ = [$x]
	Return $_
EndFunc   ;==>V1

Func V2($x = 0, $y = 0)
	Local $_ = [$x, $y]
	Return $_
EndFunc   ;==>V2

Func V3($x = 0, $y = 0, $z = 0)
	Local $_ = [$x, $y, $z]
	Return $_
EndFunc   ;==>V3

Func V4($x = 0, $y = 0, $z = 0, $w = 0)
	Local $_ = [$x, $y, $z, $w]
	Return $_
EndFunc   ;==>V4

Func M33($a = 0, $b = 0, $c = 0, $d = 0, $e = 0, $f = 0, $g = 0, $h = 0, $i = 0)
	Local $_ = [[$a, $b, $c], [$d, $e, $f], [$g, $h, $i]]
	Return $_
EndFunc

Func M44($a = 0, $b = 0, $c = 0, $d = 0, $e = 0, $f = 0, $g = 0, $h = 0, $i = 0, $j = 0, $k = 0, $l = 0, $m = 0, $n = 0, $o = 0, $p = 0)
	Local $_ = [[$a, $b, $c, $d], [$e, $f, $g, $h], [$i, $j, $k, $l], [$m, $n, $o, $p]]
	Return $_
EndFunc

; Rotationsmatrix 3x3 via Eulervektor + Winkel
Func R33Euler($e, $A)
	Local $_ = [ _
			[$e[0] ^ 2 * (1 - Cos($A)) + Cos($A), $e[0] * $e[1] * (1 - Cos($A)) - $e[2] * Sin($A), $e[0] * $e[2] * (1 - Cos($A)) + $e[1] * Sin($A)], _
			[$e[1] * $e[0] * (1 - Cos($A)) + $e[2] * Sin($A), $e[1] ^ 2 * (1 - Cos($A)) + Cos($A), $e[1] * $e[2] * (1 - Cos($A)) - $e[0] * Sin($A)], _
			[$e[2] * $e[0] * (1 - Cos($A)) - $e[1] * Sin($A), $e[2] * $e[1] * (1 - Cos($A)) + $e[0] * Sin($A), $e[2] ^ 2 * (1 - Cos($A)) + Cos($A)]]
	Return $_
EndFunc   ;==>R33Euler

; Rotationsmatrix 3x3 fr Winkel $x
Func R33X($x)
	Local $_ = [[1, 0, 0], [0, Cos($x), -Sin($x)], [0, Sin($x), Cos($x)]]
	Return $_
EndFunc   ;==>R33X

; Rotationsmatrix 3x3 fr Winkel $y
Func R33Y($y)
	Local $_ = [[Cos($y), 0, Sin($y)], [0, 1, 0], [-Sin($y), 0, Cos($y)]]
	Return $_
EndFunc   ;==>R33Y

; Rotationsmatrix 3x3 fr Winkel $z
Func R33Z($z)
	Local $_ = [[Cos($z), -Sin($z), 0], [Sin($z), Cos($z), 0], [0, 0, 1]]
	Return $_
EndFunc   ;==>R33Z

Func S33XY($x, $y) ; Scherung entlang der XY ebene
	Local $_ = [[1, 0, $x], [0, 1, $y], [0, 0, 1]]
	Return $_
EndFunc

Func S33YZ($y, $z) ; Scherung entlang der XY ebene
	Local $_ = [[1, 0, 0], [$y, 1, 0], [$z, 0, 1]]
	Return $_
EndFunc

Func S33ZX($z, $x) ; Scherung entlang der XY ebene
	Local $_ = [[1, $x, 0], [0, 1, 0], [0, $z, 1]]
	Return $_
EndFunc

; Rotationsmatrix 3x3 fr Winkel $x, $y, $z (in dieser Reihenfolge)
Func R33XYZ($x, $y, $z)
	Local $_ = [ _
			[Cos($y) * Cos($z), -Cos($y) * Sin($z), Sin($y)], _
			[Sin($x) * Sin($y) * Cos($z) + Cos($x) * Sin($z), -Sin($x) * Sin($y) * Sin($z) + Cos($x) * Cos($z), -Sin($x) * Cos($y)], _
			[-Sin($y) * Cos($x) * Cos($z) + Sin($x) * Sin($z), Sin($y) * Cos($x) * Sin($z) + Sin($x) * Cos($z), Cos($x) * Cos($y)]]
	Return $_
EndFunc   ;==>R33XYZ

; Rotationsmatrix fr die Rotation um eine beliebige Achse (gegeben durch den Vektor $n) um den Winkel $a
Func R33Axis(ByRef $n, $a)
	Local $_ = [ _
	[$n[0]^2*(1-Cos($a))+Cos($a), $n[0]*$n[1]*(1-Cos($a))-$n[2]*Sin($a), $n[0]*$n[2]*(1-Cos($a))+$n[1]*Sin($a)], _
	[$n[1]*$n[0]*(1-Cos($a))+$n[2]*Sin($a), $n[1]^2*(1-Cos($a))+Cos($a), $n[1]*$n[2]*(1-Cos($a))-$n[0]*Sin($a)], _
	[$n[2]*$n[0]*(1-Cos($a))-$n[1]*Sin($a), $n[2]*$n[1]*(1-Cos($a))+$n[0]*Sin($a), $n[2]^2*(1-Cos($a))+Cos($a)]]
	Return $_
EndFunc

; Diagonalmatrix mit skalaren Eintrgen x auf der Diagonalen
Func M33DiagS($x)
	Local $_ = [[$x, 0, 0], [0, $x, 0], [0, 0, $x]]
	Return $_
EndFunc

; Diagonalmatrix mit skalaren Eintrgen x auf der Diagonalen
Func M33DiagV($v)
	Local $_ = [[$v[0], 0, 0], [0, $v[1], 0], [0, 0, $v[2]]]
	Return $_
EndFunc

; Diagonalmatrix mit den Eintrgen x y z auf der Diagonalen
Func M33DiagXYZ($x, $y, $z)
	Local $_ = [[$x, 0, 0], [0, $y, 0], [0, 0, $z]]
	Return $_
EndFunc





; ##### Vektor & Matrixfunktionen #####

Func M33CrossV($v) ; Kreuzproduktmatrix des Vektors V
	Local $_ = [ _
	[  0   , -$v[2],  $v[1]], _
	[ $v[2],   0   , -$v[0]], _
	[-$v[1],  $v[0],   0   ]]
	Return $_
EndFunc

Func M33CrossXYZ($x, $y, $z) ; Kreuzproduktmatrix des Vektors V
	Local $_ = [ _
	[  0, -$z,  $y], _
	[ $z,   0   , -$x], _
	[-$y,  $x,   0   ]]
	Return $_
EndFunc

Func V3Perp($U)
	; Teile durch den grten Wert (auer er ist 0, dann ist es ein Nullvektor)
	Local $aLen = [Abs($U[0]), Abs($U[1]), Abs($U[2])], $iMax = 0
	If $aLen[1] > $aLen[$iMax] Then $iMax = 1
	If $aLen[2] > $aLen[$iMax] Then $iMax = 2
	If $aLen[$iMax] <= $__LA_EPS Then Return $U ; Das war ein Nullvektor...
	Switch $iMax
		Case 0 ; x war am grten
			Return V3(-($U[1] + $U[2]) / $U[0], 1, 1) ; [(y+z)/(-x), 1, 1] steht senktecht auf [x, y, z]
		Case 1 ; y war am grten
			Return V3(1, -($U[0] + $U[2]) / $U[1], 1) ; [1, (x+z)/(-y), 1] steht senktecht auf [x, y, z]
		Case 2 ; z war am grten
			Return V3(1, 1, -($U[0] + $U[1]) / $U[2]) ; [1, 1, (x+y)/(-z)] steht senktecht auf [x, y, z]
	EndSwitch
EndFunc

Func V3PerpR(ByRef $U)
	; Teile durch den grten Wert (auer er ist 0, dann ist es ein Nullvektor)
	Local $aLen = [Abs($U[0]), Abs($U[1]), Abs($U[2])], $iMax = 0
	If $aLen[1] > $aLen[$iMax] Then $iMax = 1
	If $aLen[2] > $aLen[$iMax] Then $iMax = 2
	If $aLen[$iMax] <= $__LA_EPS Then Return $U ; Das war ein Nullvektor...
	Switch $iMax
		Case 0 ; x war am grten
			Return V3(-($U[1] + $U[2]) / $U[0], 1, 1) ; [(y+z)/(-x), 1, 1] steht senktecht auf [x, y, z]
		Case 1 ; y war am grten
			Return V3(1, -($U[0] + $U[2]) / $U[1], 1) ; [1, (x+z)/(-y), 1] steht senktecht auf [x, y, z]
		Case 2 ; z war am grten
			Return V3(1, 1, -($U[0] + $U[1]) / $U[2]) ; [1, 1, (x+y)/(-z)] steht senktecht auf [x, y, z]
	EndSwitch
EndFunc

Func V3Perpeq(ByRef $U)
	; Teile durch den grten Wert (auer er ist 0, dann ist es ein Nullvektor)
	Local $aLen = [Abs($U[0]), Abs($U[1]), Abs($U[2])], $iMax = 0
	If $aLen[1] > $aLen[$iMax] Then $iMax = 1
	If $aLen[2] > $aLen[$iMax] Then $iMax = 2
	If $aLen[$iMax] <= $__LA_EPS Then Return ; Das war ein Nullvektor... das bleibt auch ein Nullvektor
	Switch $iMax
		Case 0 ; x war am grten
			$U = V3(-($U[1] + $U[2]) / $U[0], 1, 1) ; [(y+z)/(-x), 1, 1] steht senktecht auf [x, y, z]
		Case 1 ; y war am grten
			$U = V3(1, -($U[0] + $U[2]) / $U[1], 1) ; [1, (x+z)/(-y), 1] steht senktecht auf [x, y, z]
		Case 2 ; z war am grten
			$U = V3(1, 1, -($U[0] + $U[1]) / $U[2]) ; [1, 1, (x+y)/(-z)] steht senktecht auf [x, y, z]
	EndSwitch
EndFunc

Func V3Neq(ByRef $a)
	Local $l = ($a[0]^2+$a[1]^2+$a[2]^2)^0.5
	If $l = 0 Then Return
	$a[0] /= $l
	$a[1] /= $l
	$a[2] /= $l
EndFunc   ;==>V3Normeq

Func V3N($a) ; Return: normalisierte Version von $U
	Local $l = Sqrt($a[0] ^ 2 + $a[1] ^ 2 + $a[2] ^ 2)
	If $l = 0 Then Return $a
	$a[0] /= $l
	$a[1] /= $l
	$a[2] /= $l
	Return $a
EndFunc   ;==>V3Norm

Func V2N($U) ; Return: normalisierte Version von $U
	Local $l = Sqrt($U[0] * $U[0] + $U[1] * $U[1])
	If $l = 0 Then Return $U
	$U[0] /= $l
	$U[1] /= $l
	Return $U
EndFunc   ;==>V3Norm

Func V3Sub($U, $V)
	Local $_ = [$U[0] - $V[0], $U[1] - $V[1], $U[2] - $V[2]]
	Return $_
EndFunc

Func V3Add($U, $V)
	Local $_ = [$U[0] + $V[0], $U[1] + $V[1], $U[2] + $V[2]]
	Return $_
EndFunc

Func V3Avg2(ByRef $a, ByRef $b)
	Local $_ = [($a[0] + $b[0])/2, ($a[1] + $b[1])/2, ($a[2] + $b[2])/2]
	Return $_
EndFunc

Func V3Avg3(ByRef $a, ByRef $b, ByRef $c)
	Local $m = [($a[0] + $b[0] + $c[0])/3, ($a[1] + $b[1] + $c[1])/3, ($a[2] + $b[2] + $c[2])/3]
	Return $m
EndFunc

Func V3Avg4(ByRef $a, ByRef $b, ByRef $c, ByRef $d)
	Local $m = [($a[0] + $b[0] + $c[0] + $d[0])/4, ($a[1] + $b[1] + $c[1] + $d[1])/4, ($a[2] + $b[2] + $c[2] + $d[2])/4]
	Return $m
EndFunc

Func V3Avg5(ByRef $a, ByRef $b, ByRef $c, ByRef $d, ByRef $e)
	Local $m = [($a[0] + $b[0] + $c[0] + $d[0] + $e[0])/5, ($a[1] + $b[1] + $c[1] + $d[1] + $e[1])/5, ($a[2] + $b[2] + $c[2] + $d[2] + $e[2])/5]
	Return $m
EndFunc

Func V3TriangleN(ByRef $a, ByRef $b, ByRef $c)
	Local $n = [($a[1] - $b[1]) * ($a[2] - $c[2]) - ($a[2] - $b[2]) * ($a[1] - $c[1]), ($a[2] - $b[2]) * ($a[0] - $c[0]) - ($a[0] - $b[0]) * ($a[2] - $c[2]), ($a[0] - $b[0]) * ($a[1] - $c[1]) - ($a[1] - $b[1]) * ($a[0] - $c[0])]
	Return $n
EndFunc

Func V3Addeq(ByRef $a, ByRef $b)
	$a[0] += $b[0]
	$a[1] += $b[1]
	$a[2] += $b[2]
EndFunc

Func V3Subeq(ByRef $a, ByRef $b)
	$a[0] -= $b[0]
	$a[1] -= $b[1]
	$a[2] -= $b[2]
EndFunc

Func V2Add($U, $V)
	Local $_ = [$U[0] + $V[0], $U[1] + $V[1]]
	Return $_
EndFunc

Func V3L($a)
	Return ($a[0] ^ 2 + $a[1] ^ 2 + $a[2] ^ 2) ^ 0.5
EndFunc   ;==>V3Len

Func V3LR($a)
	Return ($a[0] ^ 2 + $a[1] ^ 2 + $a[2] ^ 2) ^ 0.5
EndFunc   ;==>V3Len

Func V3SetL(ByRef $a, ByRef $n)
	Local $l = ($a[0] * $a[0] + $a[1] * $a[1] + $a[2] * $a[2])^0.5 / $n
	$a[0] /= $l
	$a[1] /= $l
	$a[2] /= $l
EndFunc

Func V3Dist($U, $V)
	Return Sqrt(($U[0] - $V[0]) ^ 2 + ($U[1] - $V[1]) ^ 2 + ($U[2] - $V[2]) ^ 2)
EndFunc   ;==>V3Dist

Func V3Crosseq(ByRef $U, $V)
	Local $_ = [$U[1] * $V[2] - $U[2] * $V[1], $U[2] * $V[0] - $U[0] * $V[2], $U[0] * $V[1] - $U[1] * $V[0]]
	$U = $_
EndFunc   ;==>V3Crosseq

Func V3Cross($a, $b)
	Local $_ = [$a[1] * $b[2] - $a[2] * $b[1], $a[2] * $b[0] - $a[0] * $b[2], $a[0] * $b[1] - $a[1] * $b[0]]
	Return $_
EndFunc   ;==>V3Cross

Func V3MulSeq(ByRef $a, ByRef $b)
	$a[0] *= $b
	$a[1] *= $b
	$a[2] *= $b
EndFunc

Func V3Dot($a, $b)
	Return $a[0] * $b[0] + $a[1] * $b[1] + $a[2] * $b[2]
EndFunc

Func V3Muleq(ByRef $a, ByRef $b)
	$a[0] *= $b[0]
	$a[1] *= $b[1]
	$a[2] *= $b[2]
EndFunc




Func V4MulS($a, $b)
	$a[0] *= $b
	$a[1] *= $b
	$a[2] *= $b
	$a[3] *= $b
	Return $a
EndFunc

Func V3MulS($a, $b)
	$a[0] *= $b
	$a[1] *= $b
	$a[2] *= $b
	Return $a
EndFunc

Func V2MulS($a, $b)
	$a[0] *= $b
	$a[1] *= $b
	Return $a
EndFunc

Func V1MulS($a, $b)
	$a[0] *= $b
	Return $a
EndFunc

Func V3DivS($a, $b)
	$a[0] /= $b
	$a[1] /= $b
	$a[2] /= $b
	Return $a
EndFunc

Func V3Diveq(ByRef $a, ByRef $b)
	$a[0] /= $b[0]
	$a[1] /= $b[1]
	$a[2] /= $b[2]
EndFunc

Func V3DivSeq(ByRef $a, $b)
	$a[0] /= $b
	$a[1] /= $b
	$a[2] /= $b
EndFunc

Func V3Indep($U, $V) ; test ob linear unabhngig
	Return V3L(V3Cross($U, $V)) < $__LA_EPS
EndFunc

Func V3Str($U, $iDigits = 5)
	Local $f = '% '&($iDigits + 3)&'.'&$iDigits&'f'
	Return '[' & StringFormat($f, $U[0]) & ' ' & StringFormat($f, $U[1]) & ' ' & StringFormat($f, $U[2]) & ']' & @CRLF
EndFunc

Func M33Str($A, $iDigits = 5)
	Local $s = '', $f = '% '&($iDigits + 3)&'.'&$iDigits&'f'
	For $i = 0 To 2 Step 1
		$s &= StringFormat($f, $A[$i][0]) & ' ' & StringFormat($f, $A[$i][1]) & ' ' & StringFormat($f, $A[$i][2]) & @CRLF
	Next
	Return $s
EndFunc

Func M33Str2($A, $iDigits = 15)
	Local $s = 'M33(', $f = '% '&($iDigits + 4)&'.'&$iDigits&'f'
	For $i = 0 To 2 Step 1
		$s &= StringFormat($f, $A[$i][0]) & ', ' & StringFormat($f, $A[$i][1]) & ', ' & StringFormat($f, $A[$i][2]) & ', '
	Next
	Return StringTrimRight($s, 2) & ')'
EndFunc

Func M33Dist($A, $B)
	Return Sqrt( _
			($A[0][0] - $B[0][0]) ^ 2 + ($A[0][1] - $B[0][1]) ^ 2 + ($A[0][2] - $B[0][2]) ^ 2 + _
			($A[1][0] - $B[1][0]) ^ 2 + ($A[1][1] - $B[1][1]) ^ 2 + ($A[1][2] - $B[1][2]) ^ 2 + _
			($A[2][0] - $B[2][0]) ^ 2 + ($A[2][1] - $B[2][1]) ^ 2 + ($A[2][2] - $B[2][2]) ^ 2)
EndFunc   ;==>M33Dist

Func M33DistR(ByRef $A, ByRef $B)
	Return Sqrt( _
			($A[0][0] - $B[0][0]) ^ 2 + ($A[0][1] - $B[0][1]) ^ 2 + ($A[0][2] - $B[0][2]) ^ 2 + _
			($A[1][0] - $B[1][0]) ^ 2 + ($A[1][1] - $B[1][1]) ^ 2 + ($A[1][2] - $B[1][2]) ^ 2 + _
			($A[2][0] - $B[2][0]) ^ 2 + ($A[2][1] - $B[2][1]) ^ 2 + ($A[2][2] - $B[2][2]) ^ 2)
EndFunc   ;==>M33DistR

; Return $A + $B (je element)
Func M33Add($A, $B)
	$A[0][0] += $B[0][0]
	$A[0][1] += $B[0][1]
	$A[0][2] += $B[0][2]
	$A[1][0] += $B[1][0]
	$A[1][1] += $B[1][1]
	$A[1][2] += $B[1][2]
	$A[2][0] += $B[2][0]
	$A[2][1] += $B[2][1]
	$A[2][2] += $B[2][2]
	Return $A
EndFunc   ;==>M33Add

; Return $A + $B (je element)
Func M33AddR($A, ByRef $B)
	$A[0][0] += $B[0][0]
	$A[0][1] += $B[0][1]
	$A[0][2] += $B[0][2]
	$A[1][0] += $B[1][0]
	$A[1][1] += $B[1][1]
	$A[1][2] += $B[1][2]
	$A[2][0] += $B[2][0]
	$A[2][1] += $B[2][1]
	$A[2][2] += $B[2][2]
	Return $A
EndFunc   ;==>M33AddR

; $A = $A + $B (je element)
Func M33Addeq(ByRef $A, $B)
	$A[0][0] += $B[0][0]
	$A[0][1] += $B[0][1]
	$A[0][2] += $B[0][2]
	$A[1][0] += $B[1][0]
	$A[1][1] += $B[1][1]
	$A[1][2] += $B[1][2]
	$A[2][0] += $B[2][0]
	$A[2][1] += $B[2][1]
	$A[2][2] += $B[2][2]
EndFunc   ;==>M33Addeq

; $A = $A + $B (je element)
Func M33AddeqR(ByRef $A, ByRef $B)
	$A[0][0] += $B[0][0]
	$A[0][1] += $B[0][1]
	$A[0][2] += $B[0][2]
	$A[1][0] += $B[1][0]
	$A[1][1] += $B[1][1]
	$A[1][2] += $B[1][2]
	$A[2][0] += $B[2][0]
	$A[2][1] += $B[2][1]
	$A[2][2] += $B[2][2]
EndFunc   ;==>M33AddeqR

; Return $A - $B (je element)
Func M33Sub($A, $B)
	$A[0][0] -= $B[0][0]
	$A[0][1] -= $B[0][1]
	$A[0][2] -= $B[0][2]
	$A[1][0] -= $B[1][0]
	$A[1][1] -= $B[1][1]
	$A[1][2] -= $B[1][2]
	$A[2][0] -= $B[2][0]
	$A[2][1] -= $B[2][1]
	$A[2][2] -= $B[2][2]
	Return $A
EndFunc   ;==>M33Sub

; Return $A - $B (je element)
Func M33SubR($A, ByRef $B)
	$A[0][0] -= $B[0][0]
	$A[0][1] -= $B[0][1]
	$A[0][2] -= $B[0][2]
	$A[1][0] -= $B[1][0]
	$A[1][1] -= $B[1][1]
	$A[1][2] -= $B[1][2]
	$A[2][0] -= $B[2][0]
	$A[2][1] -= $B[2][1]
	$A[2][2] -= $B[2][2]
	Return $A
EndFunc   ;==>M33SubR

; $A = $A + $B (je element)
Func M33Subeq(ByRef $A, $B)
	$A[0][0] -= $B[0][0]
	$A[0][1] -= $B[0][1]
	$A[0][2] -= $B[0][2]
	$A[1][0] -= $B[1][0]
	$A[1][1] -= $B[1][1]
	$A[1][2] -= $B[1][2]
	$A[2][0] -= $B[2][0]
	$A[2][1] -= $B[2][1]
	$A[2][2] -= $B[2][2]
EndFunc   ;==>M33Subeq

; $A = $A + $B (je element)
Func M33SubeqR(ByRef $A, ByRef $B)
	$A[0][0] -= $B[0][0]
	$A[0][1] -= $B[0][1]
	$A[0][2] -= $B[0][2]
	$A[1][0] -= $B[1][0]
	$A[1][1] -= $B[1][1]
	$A[1][2] -= $B[1][2]
	$A[2][0] -= $B[2][0]
	$A[2][1] -= $B[2][1]
	$A[2][2] -= $B[2][2]
EndFunc   ;==>M33SubeqR

; Return $A^T * $A
; Heraus kommt eine symmetrische Matrix. (jede symmetrische Matrix ist auch normal)
Func M33Sq($A)
	Local $_ = M33TR($A)
	Return M33MulM33R($_, $A)
EndFunc   ;==>M33Sq

; Return $A^T * $A
Func M33SqR(ByRef $A)
	Local $_ = M33TR($A)
	Return M33MulM33R($_, $A)
EndFunc   ;==>M33SqR

; $A = $A^T * $A
Func M33Sqeq(ByRef $A)
	Local $_ = M33TR($A)
	$A = M33MulM33R($_, $A)
EndFunc   ;==>M33Sqeq

; Return: $v = $A * $v
Func M33MulV3eq($A, ByRef $v)
	Local $_ = [ _
			$A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2], _
			$A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2], _
			$A[2][0] * $v[0] + $A[2][1] * $v[1] + $A[2][2] * $v[2]]
	$v = $_
EndFunc   ;==>M33MulV3eq

; Return: $v = $A * $v
Func M33MulV3eqR(ByRef $A, ByRef $v)
	Local $_ = [ _
			$A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2], _
			$A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2], _
			$A[2][0] * $v[0] + $A[2][1] * $v[1] + $A[2][2] * $v[2]]
	$v = $_
EndFunc   ;==>M33MulV3eqR

; Return: $A * $v
Func M33MulV3($A, $v)
	Local $_ = [ _
			$A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2], _
			$A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2], _
			$A[2][0] * $v[0] + $A[2][1] * $v[1] + $A[2][2] * $v[2]]
	Return $_
EndFunc   ;==>M33MulV3

; Return: $A * $v
Func M33MulV3R(ByRef $A, ByRef $v)
	Local $_ = [ _
			$A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2], _
			$A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2], _
			$A[2][0] * $v[0] + $A[2][1] * $v[1] + $A[2][2] * $v[2]]
	Return $_
EndFunc   ;==>M33MulV3R

; Return Matrixmultiply A * B
Func M33MulM33($A, $B)
	Local $_ = [ _
			[$A[0][0] * $B[0][0] + $A[0][1] * $B[1][0] + $A[0][2] * $B[2][0], _
			$A[0][0] * $B[0][1] + $A[0][1] * $B[1][1] + $A[0][2] * $B[2][1], _
			$A[0][0] * $B[0][2] + $A[0][1] * $B[1][2] + $A[0][2] * $B[2][2]], _
			[$A[1][0] * $B[0][0] + $A[1][1] * $B[1][0] + $A[1][2] * $B[2][0], _
			$A[1][0] * $B[0][1] + $A[1][1] * $B[1][1] + $A[1][2] * $B[2][1], _
			$A[1][0] * $B[0][2] + $A[1][1] * $B[1][2] + $A[1][2] * $B[2][2]], _
			[$A[2][0] * $B[0][0] + $A[2][1] * $B[1][0] + $A[2][2] * $B[2][0], _
			$A[2][0] * $B[0][1] + $A[2][1] * $B[1][1] + $A[2][2] * $B[2][1], _
			$A[2][0] * $B[0][2] + $A[2][1] * $B[1][2] + $A[2][2] * $B[2][2]]]
	Return $_
EndFunc   ;==>M33Mul


Func M44MulM44(ByRef $A, ByRef $B)
	Local $_ = [ _
			[$A[0][0] * $B[0][0] + $A[0][1] * $B[1][0] + $A[0][2] * $B[2][0] + $A[0][3] * $B[3][0], _
			$A[0][0] * $B[0][1] + $A[0][1] * $B[1][1] + $A[0][2] * $B[2][1] + $A[0][3] * $B[3][1], _
			$A[0][0] * $B[0][2] + $A[0][1] * $B[1][2] + $A[0][2] * $B[2][2] + $A[0][3] * $B[3][2], _
			$A[0][0] * $B[0][3] + $A[0][1] * $B[1][3] + $A[0][2] * $B[2][3] + $A[0][3] * $B[3][3]], _
			[$A[1][0] * $B[0][0] + $A[1][1] * $B[1][0] + $A[1][2] * $B[2][0] + $A[1][3] * $B[3][0], _
			$A[1][0] * $B[0][1] + $A[1][1] * $B[1][1] + $A[1][2] * $B[2][1] + $A[1][3] * $B[3][1], _
			$A[1][0] * $B[0][2] + $A[1][1] * $B[1][2] + $A[1][2] * $B[2][2] + $A[1][3] * $B[3][2], _
			$A[1][0] * $B[0][3] + $A[1][1] * $B[1][3] + $A[1][2] * $B[2][3] + $A[1][3] * $B[3][3]], _
			[$A[2][0] * $B[0][0] + $A[2][1] * $B[1][0] + $A[2][2] * $B[2][0] + $A[2][3] * $B[3][0], _
			$A[2][0] * $B[0][1] + $A[2][1] * $B[1][1] + $A[2][2] * $B[2][1] + $A[2][3] * $B[3][1], _
			$A[2][0] * $B[0][2] + $A[2][1] * $B[1][2] + $A[2][2] * $B[2][2] + $A[2][3] * $B[3][2], _
			$A[2][0] * $B[0][3] + $A[2][1] * $B[1][3] + $A[2][2] * $B[2][3] + $A[2][3] * $B[3][3]], _
			[$A[3][0] * $B[0][0] + $A[3][1] * $B[1][0] + $A[3][2] * $B[2][0] + $A[3][3] * $B[3][0], _
			$A[3][0] * $B[0][1] + $A[3][1] * $B[1][1] + $A[3][2] * $B[2][1] + $A[3][3] * $B[3][1], _
			$A[3][0] * $B[0][2] + $A[3][1] * $B[1][2] + $A[3][2] * $B[2][2] + $A[3][3] * $B[3][2], _
			$A[3][0] * $B[0][3] + $A[3][1] * $B[1][3] + $A[3][2] * $B[2][3] + $A[3][3] * $B[3][3]]]
	Return $_
EndFunc

Func M44MulM33(ByRef $A, ByRef $B) ; $B33 wird als B44 mit 1 auf der Diagonalen und sonst berall 0 interpretiert.
	Local $_ = [ _
			[$A[0][0] * $B[0][0] + $A[0][1] * $B[1][0] + $A[0][2] * $B[2][0], $A[0][0] * $B[0][1] + $A[0][1] * $B[1][1] + $A[0][2] * $B[2][1], $A[0][0] * $B[0][2] + $A[0][1] * $B[1][2] + $A[0][2] * $B[2][2], $A[0][3]], _
			[$A[1][0] * $B[0][0] + $A[1][1] * $B[1][0] + $A[1][2] * $B[2][0], $A[1][0] * $B[0][1] + $A[1][1] * $B[1][1] + $A[1][2] * $B[2][1], $A[1][0] * $B[0][2] + $A[1][1] * $B[1][2] + $A[1][2] * $B[2][2], $A[1][3]], _
			[$A[2][0] * $B[0][0] + $A[2][1] * $B[1][0] + $A[2][2] * $B[2][0], $A[2][0] * $B[0][1] + $A[2][1] * $B[1][1] + $A[2][2] * $B[2][1], $A[2][0] * $B[0][2] + $A[2][1] * $B[1][2] + $A[2][2] * $B[2][2], $A[2][3]], _
			[$A[3][0] * $B[0][0] + $A[3][1] * $B[1][0] + $A[3][2] * $B[2][0], $A[3][0] * $B[0][1] + $A[3][1] * $B[1][1] + $A[3][2] * $B[2][1], $A[3][0] * $B[0][2] + $A[3][1] * $B[1][2] + $A[3][2] * $B[2][2], $A[3][3]]]
	Return $_
EndFunc

Func M33Add3($A, $B, $C)
	Return M33Add(M33Add($A, $B), $C)
EndFunc

Func M33Mul3($A, $B, $C)
	Return M33MulM33(M33MulM33($A, $B), $C)
EndFunc

; Return Matrixmultiply A * B
Func M33MulM33R(ByRef $A, ByRef $B)
	Local $_ = [ _
			[$A[0][0] * $B[0][0] + $A[0][1] * $B[1][0] + $A[0][2] * $B[2][0], _
			$A[0][0] * $B[0][1] + $A[0][1] * $B[1][1] + $A[0][2] * $B[2][1], _
			$A[0][0] * $B[0][2] + $A[0][1] * $B[1][2] + $A[0][2] * $B[2][2]], _
			[$A[1][0] * $B[0][0] + $A[1][1] * $B[1][0] + $A[1][2] * $B[2][0], _
			$A[1][0] * $B[0][1] + $A[1][1] * $B[1][1] + $A[1][2] * $B[2][1], _
			$A[1][0] * $B[0][2] + $A[1][1] * $B[1][2] + $A[1][2] * $B[2][2]], _
			[$A[2][0] * $B[0][0] + $A[2][1] * $B[1][0] + $A[2][2] * $B[2][0], _
			$A[2][0] * $B[0][1] + $A[2][1] * $B[1][1] + $A[2][2] * $B[2][1], _
			$A[2][0] * $B[0][2] + $A[2][1] * $B[1][2] + $A[2][2] * $B[2][2]]]
	Return $_
EndFunc   ;==>M33MulR

; $A = $A * $B
Func M33Muleq(ByRef $A, $B)
	Local $_ = [ _
			[$A[0][0] * $B[0][0] + $A[0][1] * $B[1][0] + $A[0][2] * $B[2][0], _
			$A[0][0] * $B[0][1] + $A[0][1] * $B[1][1] + $A[0][2] * $B[2][1], _
			$A[0][0] * $B[0][2] + $A[0][1] * $B[1][2] + $A[0][2] * $B[2][2]], _
			[$A[1][0] * $B[0][0] + $A[1][1] * $B[1][0] + $A[1][2] * $B[2][0], _
			$A[1][0] * $B[0][1] + $A[1][1] * $B[1][1] + $A[1][2] * $B[2][1], _
			$A[1][0] * $B[0][2] + $A[1][1] * $B[1][2] + $A[1][2] * $B[2][2]], _
			[$A[2][0] * $B[0][0] + $A[2][1] * $B[1][0] + $A[2][2] * $B[2][0], _
			$A[2][0] * $B[0][1] + $A[2][1] * $B[1][1] + $A[2][2] * $B[2][1], _
			$A[2][0] * $B[0][2] + $A[2][1] * $B[1][2] + $A[2][2] * $B[2][2]]]
	$A = $_
EndFunc   ;==>M33Muleq

; $A * $A * $B
Func M33MuleqR(ByRef $A, ByRef $B)
	Local $_ = [ _
			[$A[0][0] * $B[0][0] + $A[0][1] * $B[1][0] + $A[0][2] * $B[2][0], _
			$A[0][0] * $B[0][1] + $A[0][1] * $B[1][1] + $A[0][2] * $B[2][1], _
			$A[0][0] * $B[0][2] + $A[0][1] * $B[1][2] + $A[0][2] * $B[2][2]], _
			[$A[1][0] * $B[0][0] + $A[1][1] * $B[1][0] + $A[1][2] * $B[2][0], _
			$A[1][0] * $B[0][1] + $A[1][1] * $B[1][1] + $A[1][2] * $B[2][1], _
			$A[1][0] * $B[0][2] + $A[1][1] * $B[1][2] + $A[1][2] * $B[2][2]], _
			[$A[2][0] * $B[0][0] + $A[2][1] * $B[1][0] + $A[2][2] * $B[2][0], _
			$A[2][0] * $B[0][1] + $A[2][1] * $B[1][1] + $A[2][2] * $B[2][1], _
			$A[2][0] * $B[0][2] + $A[2][1] * $B[1][2] + $A[2][2] * $B[2][2]]]
	$A = $_
EndFunc   ;==>M33MuleqR

Func M33MulS($A, $S) ; Matrix * Skalar
	Local $_ = [ _
			[$S * $A[0][0], $S * $A[0][1], $S * $A[0][2]], _
			[$S * $A[1][0], $S * $A[1][1], $S * $A[1][2]], _
			[$S * $A[2][0], $S * $A[2][1], $S * $A[2][2]]]
	Return $_
EndFunc   ;==>M33MulS

Func M33MulSR(ByRef $A, $S) ; Matrix * Skalar
	Local $_ = [ _
			[$S * $A[0][0], $S * $A[0][1], $S * $A[0][2]], _
			[$S * $A[1][0], $S * $A[1][1], $S * $A[1][2]], _
			[$S * $A[2][0], $S * $A[2][1], $S * $A[2][2]]]
	Return $_
EndFunc   ;==>M33MulS

Func M33MulSeq(ByRef $A, $S) ; Matrix * Skalar
	Local $_ = [ _
			[$S * $A[0][0], $S * $A[0][1], $S * $A[0][2]], _
			[$S * $A[1][0], $S * $A[1][1], $S * $A[1][2]], _
			[$S * $A[2][0], $S * $A[2][1], $S * $A[2][2]]]
	$A = $_
EndFunc   ;==>M33MulS

Func M33DivS($A, $S) ; Matrix / Skalar
	Local $_ = [ _
			[$A[0][0] / $S, $A[0][1] / $S, $A[0][2] / $S], _
			[$A[1][0] / $S, $A[1][1] / $S, $A[1][2] / $S], _
			[$A[2][0] / $S, $A[2][1] / $S, $A[2][2] / $S]]
	Return $_
EndFunc   ;==>M33DivS

Func M33DivSR(ByRef $A, $S) ; Matrix / Skalar
	Local $_ = [ _
			[$A[0][0] / $S, $A[0][1] / $S, $A[0][2] / $S], _
			[$A[1][0] / $S, $A[1][1] / $S, $A[1][2] / $S], _
			[$A[2][0] / $S, $A[2][1] / $S, $A[2][2] / $S]]
	Return $_
EndFunc   ;==>M33DivS

Func M33DivSeq(ByRef $A, $S) ; Matrix / Skalar
	Local $_ = [ _
			[$A[0][0] / $S, $A[0][1] / $S, $A[0][2] / $S], _
			[$A[1][0] / $S, $A[1][1] / $S, $A[1][2] / $S], _
			[$A[2][0] / $S, $A[2][1] / $S, $A[2][2] / $S]]
	$A = $_
EndFunc   ;==>M33DivS

Func M33Trace($A)
	Return $A[0][0] + $A[1][1] + $A[2][2]
EndFunc   ;==>M33Trace

; Return: Determinant of $A
Func M33Det($A)
	Return $A[0][0] * ($A[1][1] * $A[2][2] - $A[1][2] * $A[2][1]) - $A[0][1] * ($A[1][0] * $A[2][2] - $A[1][2] * $A[2][0]) + $A[0][2] * ($A[1][0] * $A[2][1] - $A[1][1] * $A[2][0])
EndFunc   ;==>M33Det

; Return: Determinant of $A
Func M33DetR(ByRef $A)
	Return $A[0][0] * ($A[1][1] * $A[2][2] - $A[1][2] * $A[2][1]) - $A[0][1] * ($A[1][0] * $A[2][2] - $A[1][2] * $A[2][0]) + $A[0][2] * ($A[1][0] * $A[2][1] - $A[1][1] * $A[2][0])
EndFunc   ;==>M33DetR

; Return: Inverse of $A
; @error = 1 -> not invertible
Func M33Inv($A)
	Local $d = M33DetR($A)
	If $d = 0 Then Return SetError(1, 0, $__LA_M33I)
	Local $_ = [[ ($A[1][1] * $A[2][2] - $A[1][2] * $A[2][1]) / $d, -($A[0][1] * $A[2][2] - $A[0][2] * $A[2][1]) / $d,  ($A[0][1] * $A[1][2] - $A[0][2] * $A[1][1]) / $d], _
			    [-($A[1][0] * $A[2][2] - $A[1][2] * $A[2][0]) / $d,  ($A[0][0] * $A[2][2] - $A[0][2] * $A[2][0]) / $d, -($A[0][0] * $A[1][2] - $A[0][2] * $A[1][0]) / $d], _
			    [ ($A[1][0] * $A[2][1] - $A[1][1] * $A[2][0]) / $d, -($A[0][0] * $A[2][1] - $A[0][1] * $A[2][0]) / $d,  ($A[0][0] * $A[1][1] - $A[0][1] * $A[1][0]) / $d]]
	Return $_
EndFunc   ;==>M33Inv

Func M33DPInv($A) ; Pseudoinverse einer Diagonalmatrix
	Local $_ = [ _
			[($A[0][0] = 0 ? 0 : 1.0 / $A[0][0]), 0, 0], _
			[0, ($A[1][1] = 0 ? 0 : 1.0 / $A[1][1]), 0], _
			[0, 0, ($A[2][2] = 0 ? 0 : 1.0 / $A[2][2])]]
	Return $_
EndFunc

; Return: Inverse of $A
; @error = 1 -> not invertible
Func M33InvR(ByRef $A)
	Local $d = M33DetR($A)
	If $d = 0 Then Return SetError(1, 0, $__LA_M33I)
	Local $_ = [[($A[1][1] * $A[2][2] - $A[1][2] * $A[2][1]) / $d, -($A[0][1] * $A[2][2] - $A[0][2] * $A[2][1]) / $d, ($A[0][1] * $A[1][2] - $A[0][2] * $A[1][1]) / $d], _
			[-($A[1][0] * $A[2][2] - $A[1][2] * $A[2][0]) / $d, ($A[0][0] * $A[2][2] - $A[0][2] * $A[2][0]) / $d, -($A[0][0] * $A[1][2] - $A[0][2] * $A[1][0]) / $d], _
			[($A[1][0] * $A[2][1] - $A[1][1] * $A[2][0]) / $d, -($A[0][0] * $A[2][1] - $A[0][1] * $A[2][0]) / $d, ($A[0][0] * $A[1][1] - $A[0][1] * $A[1][0]) / $d]]
	Return $_
EndFunc   ;==>M33InvR

; $A = Inverse of $A
; @error = 1 -> not invertible
Func M33Inveq(ByRef $A)
	Local $d = M33DetR($A)
	If $d = 0 Then Return SetError(1, 0, $__LA_M33I)
	Local $_ = [[($A[1][1] * $A[2][2] - $A[1][2] * $A[2][1]) / $d, -($A[0][1] * $A[2][2] - $A[0][2] * $A[2][1]) / $d, ($A[0][1] * $A[1][2] - $A[0][2] * $A[1][1]) / $d], _
			[-($A[1][0] * $A[2][2] - $A[1][2] * $A[2][0]) / $d, ($A[0][0] * $A[2][2] - $A[0][2] * $A[2][0]) / $d, -($A[0][0] * $A[1][2] - $A[0][2] * $A[1][0]) / $d], _
			[($A[1][0] * $A[2][1] - $A[1][1] * $A[2][0]) / $d, -($A[0][0] * $A[2][1] - $A[0][1] * $A[2][0]) / $d, ($A[0][0] * $A[1][1] - $A[0][1] * $A[1][0]) / $d]]
	$A = $_
EndFunc   ;==>M33Inveq

Func M33FromRows($U, $V, $W)
	Local $_ = [ _
		[$U[0], $U[1], $U[2]], _
		[$V[0], $V[1], $V[2]], _
		[$W[0], $W[1], $W[2]]]
	Return $_
EndFunc

Func M33FromCols($U, $V, $W)
	Local $_ = [ _
		[$U[0], $V[0], $W[0]], _
		[$U[1], $V[1], $W[1]], _
		[$U[2], $V[2], $W[2]]]
	Return $_
EndFunc

; Return: V3(row1, row2, row3) mit rowN = V3
Func M33Rows($A)
	Local $1 = [$A[0][0], $A[0][1], $A[0][2]], $2 = [$A[1][0], $A[1][1], $A[1][2]], $3 = [$A[2][0], $A[2][1], $A[2][2]], $R = [$1, $2, $3]
	Return $R
EndFunc

; Return: V3(col1, col2, col3) mit colN = V3
Func M33Cols($A)
	Local $1 = [$A[0][0], $A[1][0], $A[2][0]], $2 = [$A[0][1], $A[1][1], $A[2][1]], $3 = [$A[0][2], $A[1][2], $A[2][2]], $R = [$1, $2, $3]
	Return $R
EndFunc

; Return: V3(row1, row2, row3) mit rowN = V3
Func M33RowsR(ByRef $A)
	Local $1 = [$A[0][0], $A[0][1], $A[0][2]], $2 = [$A[1][0], $A[1][1], $A[1][2]], $3 = [$A[2][0], $A[2][1], $A[2][2]], $R = [$1, $2, $3]
	Return $R
EndFunc

; Return: V3(col1, col2, col3) mit colN = V3
Func M33ColsR(ByRef $A)
	Local $1 = [$A[0][0], $A[1][0], $A[2][0]], $2 = [$A[0][1], $A[1][1], $A[2][1]], $3 = [$A[0][2], $A[1][2], $A[2][2]], $R = [$1, $2, $3]
	Return $R
EndFunc

; Return: Transposed $A
Func M33T($A)
	Local $_ = [ _
			[$A[0][0], $A[1][0], $A[2][0]], _
			[$A[0][1], $A[1][1], $A[2][1]], _
			[$A[0][2], $A[1][2], $A[2][2]]]
	Return $_
EndFunc   ;==>M33T

; Return: Transposed $A
Func M33TR(ByRef $A)
	Local $_ = [ _
			[$A[0][0], $A[1][0], $A[2][0]], _
			[$A[0][1], $A[1][1], $A[2][1]], _
			[$A[0][2], $A[1][2], $A[2][2]]]
	Return $_
EndFunc   ;==>M33TR

; $A = Transposed $A
Func M33Teq(ByRef $A)
	Local $_ = [$A[1][0], $A[2][0], $A[2][1]]
	$A[1][0] = $A[0][1]
	$A[0][1] = $_[0]
	$A[2][0] = $A[0][2]
	$A[0][2] = $_[1]
	$A[2][1] = $A[1][2]
	$A[1][2] = $_[3]
EndFunc   ;==>M33Teq

; Sortiert einen Vektor absteigend
Func V3SortD($V)
	Local $_
	If $V[0] < $V[1] Then
		$_ = $V[0]
		$V[0] = $V[1]
		$V[1] = $_
	EndIf
	If $V[1] < $V[2] Then
		$_ = $V[1]
		$V[1] = $V[2]
		$V[2] = $_
	EndIf
	If $V[0] < $V[1] Then
		$_ = $V[0]
		$V[0] = $V[1]
		$V[1] = $_
	EndIf
	Return $V
EndFunc

; Sortiert einen Vektor aufsteigend
Func V3SortA($V)
	Local $_
	If $V[0] > $V[1] Then
		$_ = $V[0]
		$V[0] = $V[1]
		$V[1] = $_
	EndIf
	If $V[1] > $V[2] Then
		$_ = $V[1]
		$V[1] = $V[2]
		$V[2] = $_
	EndIf
	If $V[0] > $V[1] Then
		$_ = $V[0]
		$V[0] = $V[1]
		$V[1] = $_
	EndIf
	Return $V
EndFunc
