#include-once

#include 'Linalg.au3'

; 3D Matrixrechnungen


Func M44TranslateXYZ(ByRef $A, ByRef $x, ByRef $y, ByRef $z)
	Local $_ = [ _
			[$A[0][0], $A[0][1], $A[0][2], $A[0][0] * $x + $A[0][1] * $y + $A[0][2] * $z + $A[0][3]], _
			[$A[1][0], $A[1][1], $A[1][2], $A[1][0] * $x + $A[1][1] * $y + $A[1][2] * $z + $A[1][3]], _
			[$A[2][0], $A[2][1], $A[2][2], $A[2][0] * $x + $A[2][1] * $y + $A[2][2] * $z + $A[2][3]], _
			[$A[3][0], $A[3][1], $A[3][2], $A[3][0] * $x + $A[3][1] * $y + $A[3][2] * $z + $A[3][3]]]
	Return $_
EndFunc  ;==>__A3D_MatrixMultiply

Func M44TranslateXYZR(ByRef $A, ByRef $x, ByRef $y, ByRef $z)
	$A[0][3] += $A[0][0] * $x + $A[0][1] * $y + $A[0][2] * $z
	$A[1][3] += $A[1][0] * $x + $A[1][1] * $y + $A[1][2] * $z
	$A[2][3] += $A[2][0] * $x + $A[2][1] * $y + $A[2][2] * $z
	$A[3][3] += $A[3][0] * $x + $A[3][1] * $y + $A[3][2] * $z
EndFunc  ;==>__A3D_MatrixMultiply

Func M44MulXYZ(ByRef $A, ByRef $x, ByRef $y, ByRef $z)
	Local $d = $A[3][0] * $x + $A[3][1] * $y + $A[3][2] * $z + $A[3][3]
	Local $_ = [ _
			($A[0][0] * $x + $A[0][1] * $y + $A[0][2] * $z + $A[0][3]) / $d, _
			($A[1][0] * $x + $A[1][1] * $y + $A[1][2] * $z + $A[1][3]) / $d, _
			($A[2][0] * $x + $A[2][1] * $y + $A[2][2] * $z + $A[2][3]) / $d]
	Return $_
EndFunc   ;==>__A3D_MatrixMultiplyXYZ

Func M44MulXYZV(ByRef $A, ByRef $v)
	Local $d = $A[3][0] * $v[0] + $A[3][1] * $v[1] + $A[3][2] * $v[2] + $A[3][3]
	Local $_ = [ _
			($A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2] + $A[0][3]) / $d, _
			($A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2] + $A[1][3]) / $d, _
			($A[2][0] * $v[0] + $A[2][1] * $v[1] + $A[2][2] * $v[2] + $A[2][3]) / $d]
	Return $_
EndFunc   ;==>__A3D_MatrixMultiplyXYZ

Func M44MulXYZV2(ByRef $A, ByRef $v)
	Local $d = $A[3][0] * $v[0] + $A[3][1] * $v[1] + $A[3][2] * $v[2] + $A[3][3]
	Local $_ = [ _
			($A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2] + $A[0][3]) / $d, _
			($A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2] + $A[1][3]) / $d]
	Return $_
EndFunc   ;==>__A3D_MatrixMultiplyXYZ


Func M33MulXYZV(ByRef $A, ByRef $v)
	Local $_ = [ _
			$A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2], _
			$A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2], _
			$A[2][0] * $v[0] + $A[2][1] * $v[1] + $A[2][2] * $v[2]]
	Return $_
EndFunc   ;==>__A3D_MatrixMultiplyXYZ


