


; Test für eine ungelockte Orbitkamera (ist noch etwas fake, da das Objekt bewegt wird und nicht die Kamera, aber zum test reichts.)
; Steuerung: Mausrad, Linksklick + Drag

#include '_A3D_Core.au3'
#include 'Include/Buffer.au3'
#include 'Include/FastHSL.au3'
#include 'Include\Linalg.au3'
#include <Misc.au3>

Opt('GuiOnEventMode', 1)
Opt('MouseCoordMode', 2)

Global $bExit = False
Func Xit()
	$bExit = True
EndFunc

Main()

Func Main()

	Local $sWindowTitle = 'Kugelgenerator'
	Local $aWindowSize = [768, 768]
	Local $Viewport = _A3D_Startup($aWindowSize[1], $aWindowSize[1])


	Local $hGUI = GUICreate('', $aWindowSize[0], $aWindowSize[1])
	Local $hDC = _WinAPI_GetDC($hGUI)
	Local $hBUF = BufferCreate($Viewport.Width, $Viewport.Height)
	Local $hGFX = _GDIPlus_GraphicsCreateFromHDC($hBUF.hDC)
;~ 	_GDIPlus_GraphicsSetSmoothingMode($hGFX, 2)

	Local $Sphere = Sphere()
	Local $iFpsTimer = TimerInit()
	Local $iFPS = 0

	; Eigentlich egal wo die Kamera sitzt, wir haben ja eine Kugel.
	_A3D_CameraPosition(0, 0, 3)

	GUISetOnEvent(-3, Xit)
	GUISetState(@SW_SHOW, $hGUI)

	While Not $bExit

		_GDIPlus_GraphicsClear($hGFX)

		_A3D_BeginScene()
;~ 		_A3D_Push()
		If WinActive($hGUI) Then
			Mouse($Viewport)
			ConditionalSleep(50)
		Else
			Sleep(50)
		EndIf
		Draw($Sphere)
;~ 		_A3D_Pop()
		_A3D_EndScene($hGFX)


		DllCall($GDI32DLL, 'bool', 'BitBlt', 'handle', $hDC, 'int', 0, 'int', 0, 'int', $A3D_WIDTH, 'int', $A3D_HEIGHT, 'handle', $hBUF.hDC, 'int', 0, 'int', 0, 'dword', 0x00CC0020)

		$iFPS += 1
		If TimerDiff($iFpsTimer) > 1000 Then
			WinSetTitle($hGUI, '', $sWindowTitle & '@' & $iFPS & ' (Vtx: ' & $A3D_VC & ' Elements: ' & $A3D_IC & ')')
			$iFPS = 0
			$iFpsTimer = TimerInit()
		EndIf

	WEnd

	_GDIPlus_GraphicsDispose($hGFX)
	_WinAPI_ReleaseDC($hGUI, $hDC)
	BufferDelete($hBUF)
	_A3D_Shutdown()


EndFunc


Func Mouse(ByRef $Viewport)
	; bewegt das Objekt, nicht die Kameramatrix.
	; -> eigene Kamera -> orbitkamera ohne Y-Lock.
	Local $aMousePos = MouseGetPos()
	Local Static $aLastMousePos = $aMousePos
	Local Static $bLastPressed = False
	Local $aMove = [$aLastMousePos[0] - $aMousePos[0], $aLastMousePos[1] - $aMousePos[1]], $iLen = Sqrt($aMove[0]^2+$aMove[1]^2)
	If $iLen = 0 Then Return

	Local $aVec3fEuler = [-$aMove[1], -$aMove[0], 0]
	V3Neq($aVec3fEuler)
	Local $inv = M33Inv($A3D_DM)
	M33MulV3eq($inv, $aVec3fEuler)

	$aLastMousePos = $aMousePos
	If _IsPressed('01') And $aMousePos[0] > 0 And $aMousePos[0] < $Viewport.Height Then
		If $bLastPressed Then
			Local $rot = R33Axis($aVec3fEuler, $A3D_CA[3] * $iLen / 500)
			_A3D_Mul($rot)
		EndIf
		$bLastPressed = True
	Else
		$bLastPressed = False
	EndIf
EndFunc

Func ConditionalSleep($iMilliseconds)
	If $A3D_CONDITIONALSLEEP Then Return
	Local $t = TimerInit()
	While TimerDiff($t) < $iMilliseconds And Not _IsPressed('01')
		Sleep(10)
	WEnd
EndFunc

Func Draw($aGeometry)
	_A3D_GeometryDraw($aGeometry)
EndFunc

Func VaryColors(ByRef $aGeo, $nPercent = 0.5)
	Local $aColors = _A3G_GetColors($aGeo), $aCol
	For $i = 0 To UBound($aColors) - 1 Step 1
		$aCol = _ColorIntToArray($aColors[$i])
		For $ii = 1 To 3 Step 1
			$aCol[$ii] = (1.0 - $nPercent) * $aCol[$ii] + $nPercent * (Random(-0.3, 0.3) + 0.7 * Random(-1, 1) * $aCol[$ii])
			If $aCol[$ii] < 0 Then $aCol[$ii] = 0
			If $aCol[$ii] > 1 Then $aCol[$ii] = 1
		Next
		$aColors[$i] = _ColorArrayToInt($aCol)
	Next
	_A3G_SetColors($aGeo, $aColors)
EndFunc

Func VaryHeight(ByRef $aGeo, $nPercent = 0.5)
	Local $aVertices = _A3G_GetVertices($aGeo), $l
	For $i = 0 To UBound($aVertices) - 1 Step 1
		$l = $nPercent * (V3L($aVertices[$i]) * Random(0.9, 1.1) + Random(-0.05, 0.05)) + (1 - $nPercent) * V3L($aVertices[$i])
		V3SetL($aVertices[$i], $l)
	Next
	_A3G_SetVertices($aGeo, $aVertices)
EndFunc

Func MinSphere(ByRef $aGeo, $iSize)
	Local $aVertices = _A3G_GetVertices($aGeo), $l
	For $i = 0 To UBound($aVertices) - 1 Step 1
		$l = V3L($aVertices[$i]) < $iSize ? $iSize : V3L($aVertices[$i])
		V3SetL($aVertices[$i], $l)
	Next
	_A3G_SetVertices($aGeo, $aVertices)
EndFunc

Func MaxSphere(ByRef $aGeo, $iSize)
	Local $aVertices = _A3G_GetVertices($aGeo), $l
	For $i = 0 To UBound($aVertices) - 1 Step 1
		$l = V3L($aVertices[$i]) > $iSize ? $iSize : V3L($aVertices[$i])
		V3SetL($aVertices[$i], $l)
	Next
	_A3G_SetVertices($aGeo, $aVertices)
EndFunc

Func Colorize(ByRef $aGeo)
	Local $aColors = _A3G_GetColors($aGeo)
	Local $aIndices = _A3G_GetIndices($aGeo)
	Local $aVertices = _A3G_GetVertices($aGeo)

	; Abhängig von der Höhe
	Local $aLimit = [V3L($aVertices[0]), V3L($aVertices[0])], $l, $aObject
	For $i = 1 To UBound($aVertices) - 1 Step 1
		$l = V3L($aVertices[$i])
		If $aLimit[0] > $l Then $aLimit[0] = $l
		If $aLimit[1] < $l Then $aLimit[1] = $l
	Next

	; Beleuchtung wird statisch berechnet.
	Local $n, $v

	Local $water = _ColorIA_RGB2HSL(0xFF0064FF)
	Local $sand = _ColorIA_RGB2HSL(0xFFE1D197)
	Local $earth = _ColorIA_RGB2HSL(0xFF3FA249)
	Local $snow = _ColorIA_RGB2HSL(0xFFD9E3E3)

	For $i = 0 To UBound($aIndices) - 1 Step 1
		$aObject = $aIndices[$i]

		; Mittlere höhe
		$l = 0
		For $ii = 1 To $aObject[0] Step 1
			$l += V3L($aVertices[$aObject[$ii]])
		Next
		$l = ($l / $aObject[0] - $aLimit[0]) / ($aLimit[1] - $aLimit[0])

		; Normalenvektor (wird crashen wenn man mit Punkten oder Linien arbeitet. Dann macht man das eben nicht)
		$n = V3TriangleN($aVertices[$aObject[1]], $aVertices[$aObject[2]], $aVertices[$aObject[3]])
		$n = V3N($n)

		;  Beleuchtungsstärke (ganz einfaches Modell ohne alles)
		$v = 0.5 * $n[0] + 0.2 * $n[0]^2 + 0.1 * $n[0]^8
		If $v < 0.1 Then $v = 0.1


		Switch $l
			Case 0 To 0.05 ; wasser sollte eigentlich immer unten sein
				$water[2] = $v
				$aColors[$i] = _ColorAI_HSL2RGB($water)
			Case 0.05 To 0.4
				$sand[2] = $v
				$aColors[$i] = _ColorAI_HSL2RGB($sand)
			Case 0.4 To 0.85
				$earth[2] = $v
				$aColors[$i] = _ColorAI_HSL2RGB($earth)
			Case Else
				$snow[2] = $v
				$aColors[$i] = _ColorAI_HSL2RGB($snow)
		EndSwitch

	Next

;~ 	ConsoleWrite(@CRLF & $aLimit[0] & ' ' & $aLimit[1])

	; Die höhen etwas dämpfen
	For $i = 0 To UBound($aVertices) - 1 Step 1
		$l = (V3L($aVertices[$i]) - $aLimit[0]) / ($aLimit[1] - $aLimit[0])
		$l = $l^2 / 2
		$l = $l * ($aLimit[1] - $aLimit[0]) + $aLimit[0]
		V3SetL($aVertices[$i], $l)
	Next

	_A3G_SetColors($aGeo, $aColors)
	_A3G_SetVertices($aGeo, $aVertices)


EndFunc

Func BreakGrid(ByRef $aGeo)
	Local $aVertices = _A3G_GetVertices($aGeo)
	Local $aIndices = _A3G_GetIndices($aGeo)

	; Statistic minLen
	Local $nMinLen =  V3L(V3Sub($aVertices[($aIndices[0])[1]], $aVertices[($aIndices[0])[2]])), $l
	For $i = 0 To Int(Sqrt(UBound($aIndices))/3) Step 1
		$l = V3L(V3Sub($aVertices[($aIndices[$i])[1]], $aVertices[($aIndices[$i])[2]]))
		If $nMinLen > $l Then $nMinLen = $l
	Next

	; Alle Punkte ein klein wenig verschieben dabei die Höhe aber nicht verändern.
	$l = $nMinLen / 4
	Local $v[3], $originalLen = 0

	For $i = 0 To UBound($aVertices) - 1 Step 1
		$v[0] = Random(-$l, $l)
		$v[1] = Random(-$l, $l)
		$v[2] = Random(-$l, $l)
		$originalLen = V3L($aVertices[$i])
		V3Addeq($aVertices[$i], $v)
		V3SetL($aVertices[$i], $originalLen)
	Next

	_A3G_SetVertices($aGeo, $aVertices)
EndFunc

Func Sphere()
	Local $aGeo = _A3D_Polyhedron($A3G_ICOSAHEDRON, 3, 0xFF2081FF)

	VaryHeight($aGeo, 1)
	_A3G_Subdiv($aGeo)
	VaryHeight($aGeo, 1)
	_A3G_Subdiv($aGeo)
	VaryHeight($aGeo, 1)
	_A3G_Subdiv($aGeo)
	VaryHeight($aGeo, 1)
	_A3G_Subdiv($aGeo)
	VaryHeight($aGeo, 0.1)

	MinSphere($aGeo, 0.85)
	MaxSphere($aGeo, 1.05)

	Colorize($aGeo)
	BreakGrid($aGeo) ; gerade linien sind doof

	Return $aGeo
EndFunc










Func _ColorIntToArray($iColor)
	Local $v = DllStructCreate('byte B;byte G;byte R;byte A'), $i = DllStructCreate('int C', DllStructGetPtr($v))
	$i.C = $iColor
	Local $_ = [$v.A / 255, $v.R / 255, $v.G / 255, $v.B / 255]
	Return $_
EndFunc   ;==>_ColorGetRGB

; #FUNCTION# ====================================================================================================================
; Author ........: Mars@AutoIt.de
; Modified.......:
; ===============================================================================================================================
Func _ColorArrayToInt($aColor)
	Local $v = DllStructCreate('byte B;byte G;byte R;byte A'), $i = DllStructCreate('int C', DllStructGetPtr($v))
	$v.A = Round($aColor[0] * 255)
	$v.R = Round($aColor[1] * 255)
	$v.G = Round($aColor[2] * 255)
	$v.B = Round($aColor[3] * 255)
	Return $i.C
EndFunc   ;==>_ColorGetRGB