#include-once
#include 'Include\Linalg.au3'
#include 'Include\Array.au3'
#include 'Include\Matrix.au3'



Func _A3G_UpdateColor(ByRef $aGeo, $iColor)
	$aGeo[2] = Repeat($iColor, UBound($aGeo[1]))
EndFunc

Func _A3G_UpdateMinMax(ByRef $aGeo)
	__A3G_UpdateMinMax($aGeo[0], $aGeo[4])
EndFunc

Func _A3G_TranslateV(ByRef $aGeo, ByRef $v)
	__A3G_TranslateV($aGeo[0], $v)
EndFunc

Func _A3G_ProjectOnSphere(ByRef $aGeo, $nSize = 1.0)
	__A3G_ProjectOnSphere($aGeo[0], $nSize)
EndFunc

Func _A3G_Rotate(ByRef $aGeo, $x, $y, $z)
	__A3G_Rotate($aGeo[0], $x, $y, $z)
EndFunc

Func _A3G_RotateV(ByRef $aGeo, $v)
	__A3G_Rotate($aGeo[0], $v[0], $v[1], $v[2])
EndFunc

Func _A3G_Scale(ByRef $aGeo, $x)
	__A3G_Scale($aGeo[0], $x)
EndFunc

Func _A3G_ScaleV(ByRef $aGeo, $v)
	__A3G_ScaleV($aGeo[0], $v)
EndFunc

Func _A3G_GetVertices(ByRef $aGeo)
	Return $aGeo[0]
EndFunc

Func _A3G_SetVertices(ByRef $aGeo, ByRef $aVertices)
	$aGeo[0] = $aVertices
	_A3G_UpdateMinMax($aGeo)
EndFunc

Func _A3G_GetIndices(ByRef $aGeo)
	Return $aGeo[1]
EndFunc

Func _A3G_GetColors(ByRef $aGeo)
	Return $aGeo[2]
EndFunc

Func _A3G_SetColors(ByRef $aGeo, ByRef $aColors)
	$aGeo[2] = $aColors
EndFunc

Func _A3G_GetMinMax(ByRef $aGeo)
	Return $aGeo[4]
EndFunc


Func _A3G_Subdiv(ByRef $aGeo)
	__A3G_Subdiv($aGeo[0], $aGeo[1], $aGeo[2], $aGeo[4])
	_A3G_UpdateMinMax($aGeo)
EndFunc


Func __A3G_Subdiv(ByRef $aVertices, ByRef $aIndices, ByRef $aColors, ByRef $aMinMax)

	Local $aScaleBox = 0, $iVertexCount = 0, $aObject = 0, $aSubdivObject = 0, $iObjectColor = 0
	Local $aLut = _VLut_Create($aVertices, $aMinMax, $aScaleBox, $iVertexCount)
	Local $Indices[]
	Local $Colors[]

	; Insert additional vertices
	For $i = 0 To UBound($aIndices) - 1 Step 1
		$aObject = $aIndices[$i]
		$iObjectColor = $aColors[$i]
		Switch $aObject[0]
			Case 1 ; point -> nicht subdividierbar, alle Punkte sind bekannt
				MapAppend($Indices, $aObject)
				MapAppend($Colors, $iObjectColor)
			Case 2 ; line -> 2 lines -> kann man zerlegen, ein Punkt fehlt
				$aSubdivObject = __A3G_SubdivLine($aVertices, $aObject, $aLut, $iVertexCount)
				For $ii = 0 To UBound($aSubdivObject) - 1 Step 1
					MapAppend($Indices, $aSubdivObject[$ii]) ; TODO -> nicht getestet
					MapAppend($Colors, $iObjectColor)
				Next
			Case 3 ; triangle 4 triangles -> jo -> standard 2D subdivision, 3 Punkte fehlen
				$aSubdivObject = __A3G_SubdivTriangle($aVertices, $aObject, $aLut, $iVertexCount)
				For $ii = 0 To UBound($aSubdivObject) - 1 Step 1
					MapAppend($Indices, $aSubdivObject[$ii])
					MapAppend($Colors, $iObjectColor)
				Next
			Case 4 ; quad -> 4 quads -> das geht auch noch, 5 Punkte fehlen
				$aSubdivObject = __A3G_SubdivQuad($aVertices, $aObject, $aLut, $iVertexCount)
				For $ii = 0 To UBound($aSubdivObject) - 1 Step 1
					MapAppend($Indices, $aSubdivObject[$ii])
					MapAppend($Colors, $iObjectColor)
				Next
			Case 5 ; pent -> meep... -> ab hier wirds eklig. Das geht leider nicht mehr... -> muss man in Dreiecke splitten... was doof ist. wir wollen ja Fünfecke :(
				$aSubdivObject = __A3G_SubdivPentagon($aVertices, $aObject, $aLut, $iVertexCount)
				For $ii = 0 To UBound($aSubdivObject) - 1 Step 1
					MapAppend($Indices, $aSubdivObject[$ii])
					MapAppend($Colors, $iObjectColor)
				Next
		EndSwitch

	Next

	$aVertices = _VLut_GetAll($aLut, $aScaleBox, $aMinMax, $iVertexCount)
	$aIndices = $Indices
	$aColors = $Colors

EndFunc

Func __A3G_SubdivLine(ByRef $aVertices, ByRef $aObject, ByRef $aLut, ByRef $iVertexCount)
	Local $i0 = $aObject[1]
	Local $i1 = $aObject[2]
	Local $i2 = _VLut_Find($aLut, V3Avg2($aVertices[$i0], $aVertices[$i1]), $iVertexCount)
	Local $l1 = [2, $i0, $i2]
	Local $l2 = [2, $i2, $i1]
	Local $aRet = [$l1, $l2]
	Return $aRet
EndFunc

Func __A3G_SubdivTriangle(ByRef $aVertices, ByRef $aObject, ByRef $aLut, ByRef $iVertexCount)
	Local $i0 = $aObject[1]
	Local $i1 = $aObject[2]
	Local $i2 = $aObject[3]
	Local $i3 = _VLut_Find($aLut, V3Avg2($aVertices[$i0], $aVertices[$i1]), $iVertexCount)
	Local $i4 = _VLut_Find($aLut, V3Avg2($aVertices[$i1], $aVertices[$i2]), $iVertexCount)
	Local $i5 = _VLut_Find($aLut, V3Avg2($aVertices[$i0], $aVertices[$i2]), $iVertexCount)
	Local $t1 = [3, $i1, $i4, $i3]
	Local $t2 = [3, $i0, $i3, $i5]
	Local $t3 = [3, $i2, $i5, $i4]
	Local $t4 = [3, $i3, $i4, $i5]
	Local $aRet = [$t1, $t2, $t3, $t4]
	Return $aRet
EndFunc

Func __A3G_SubdivQuad(ByRef $aVertices, ByRef $aObject, ByRef $aLut, ByRef $iVertexCount)
	Local $i0 = $aObject[1]
	Local $i1 = $aObject[2]
	Local $i2 = $aObject[3]
	Local $i3 = $aObject[4]
	Local $i4 = _VLut_Find($aLut, V3Avg2($aVertices[$i0], $aVertices[$i1]), $iVertexCount)
	Local $i5 = _VLut_Find($aLut, V3Avg2($aVertices[$i1], $aVertices[$i2]), $iVertexCount)
	Local $i6 = _VLut_Find($aLut, V3Avg2($aVertices[$i2], $aVertices[$i3]), $iVertexCount)
	Local $i7 = _VLut_Find($aLut, V3Avg2($aVertices[$i3], $aVertices[$i0]), $iVertexCount)
	Local $i8 = _VLut_Find($aLut, V3Avg4($aVertices[$i0], $aVertices[$i1], $aVertices[$i2], $aVertices[$i3]), $iVertexCount)

	Local $q1 = [4, $i0, $i4, $i8, $i7]
	Local $q2 = [4, $i4, $i1, $i5, $i8]
	Local $q3 = [4, $i5, $i2, $i6, $i8]
	Local $q4 = [4, $i6, $i3, $i7, $i8]
	Local $aRet = [$q1, $q2, $q3, $q4]
	Return $aRet
EndFunc

Func __A3G_SubdivPentagon(ByRef $aVertices, ByRef $aObject, ByRef $aLut, ByRef $iVertexCount)
	Local $i0 = $aObject[1]
	Local $i1 = $aObject[2]
	Local $i2 = $aObject[3]
	Local $i3 = $aObject[4]
	Local $i4 = $aObject[5]
	Local $i5 = _VLut_Find($aLut, V3Avg5($aVertices[$i0], $aVertices[$i1], $aVertices[$i2], $aVertices[$i3], $aVertices[$i4]), $iVertexCount)
	Local $t1 = [3, $i0, $i1, $i5]
	Local $t2 = [3, $i1, $i2, $i5]
	Local $t3 = [3, $i2, $i3, $i5]
	Local $t4 = [3, $i3, $i4, $i5]
	Local $t5 = [3, $i4, $i0, $i5]
	Local $aRet = [$t1, $t2, $t3, $t4, $t5]
	Return $aRet
EndFunc

Func __A3G_ProjectOnSphere(ByRef $aVertices, ByRef $nSize)
	For $i = 0 To UBound($aVertices) - 1 Step 1
		V3SetL($aVertices[$i], $nSize)
	Next
EndFunc   ;==>__GeometryTranslate

Func __A3G_TranslateV(ByRef $aVertices, ByRef $v)
	For $i = 0 To UBound($aVertices) - 1 Step 1
		V3Addeq($aVertices[$i], $v)
	Next
EndFunc   ;==>__GeometryTranslate

Func __A3G_ScaleV(ByRef $aVertices, ByRef $v)
	For $i = 0 To UBound($aVertices) - 1 Step 1
		V3Muleq($aVertices[$i], $v)
	Next
EndFunc   ;==>__GeometryScale

Func __A3G_Scale(ByRef $aVertices, ByRef $fScale)
	For $i = 0 To UBound($aVertices) - 1 Step 1
		V3MulSeq($aVertices[$i], $fScale)
	Next
EndFunc

Func __A3G_Rotate(ByRef $aVertices, ByRef $x, ByRef $y, ByRef $z)
	Local $aRot = [[Cos($y) * Cos($z), -Cos($y) * Sin($z), Sin($y)], [Sin($x) * Sin($y) * Cos($z) + Cos($x) * Sin($z), -Sin($x) * Sin($y) * Sin($z) + Cos($x) * Cos($z), -Sin($x) * Cos($y)], [-Sin($y) * Cos($x) * Cos($z) + Sin($x) * Sin($z), Sin($y) * Cos($x) * Sin($z) + Sin($x) * Cos($z), Cos($x) * Cos($y)]]
	For $i = 0 To UBound($aVertices) - 1 Step 1
		$aVertices[$i] = M33MulXYZV($aRot, $aVertices[$i])
	Next
EndFunc

Func __A3G_UpdateMinMax(ByRef $aVertices, ByRef $aMinMax)
	Local $aNew = [0, 0, 0, 0, 0, 0]
	If UBound($aVertices) Then
		$aNew[0] = ($aVertices[0])[0] ; minX
		$aNew[1] = ($aVertices[0])[1] ; minY
		$aNew[2] = ($aVertices[0])[2] ; minZ
		$aNew[3] = ($aVertices[0])[0] ; maxX
		$aNew[4] = ($aVertices[0])[1] ; maxY
		$aNew[5] = ($aVertices[0])[2] ; maxZ
		For $i = 1 To UBound($aVertices) - 1 Step 1
			If ($aVertices[$i])[0] < $aNew[0] Then $aNew[0] = ($aVertices[$i])[0]
			If ($aVertices[$i])[1] < $aNew[1] Then $aNew[1] = ($aVertices[$i])[1]
			If ($aVertices[$i])[2] < $aNew[2] Then $aNew[2] = ($aVertices[$i])[2]
			If ($aVertices[$i])[0] > $aNew[3] Then $aNew[3] = ($aVertices[$i])[0]
			If ($aVertices[$i])[1] > $aNew[4] Then $aNew[4] = ($aVertices[$i])[1]
			If ($aVertices[$i])[2] > $aNew[5] Then $aNew[5] = ($aVertices[$i])[2]
		Next
	EndIf
	$aMinMax = $aNew
EndFunc

#include '_A3D_LookupTable.au3' ; Bug im Au3Check -> Reine Funktionssammlungen lieber "danach" includen.
