
; Script Start - Add your code below here
#include-once
#include '_A3D_Header.au3'
#include 'Include\Matrix.au3'

; Matrixstack
Global $A3D_MS[$A3D_MATRIXSTACK_LIMIT] = [$A3D_MATI] ; enthält jeweils eine 4x4 Matrix (homogene Koordinaten)
Global $A3D_MC = 0 ; Anzahl Matrizen im Stack


Func _A3D_Push()
	$A3D_MS[$A3D_MC] = $A3D_DM
	$A3D_MC += 1
EndFunc

Func _A3D_Pop()
	If $A3D_MC >= 1 Then
		$A3D_MC -= 1
		$A3D_DM = $A3D_MS[$A3D_MC]
	Else
		Return ConsoleWrite('ERROR: _A3D_Pop: Matrixstack empty.' & @CRLF)
	EndIf
EndFunc

Func _A3D_Mul(ByRef $m)
	$A3D_DM = M44MulM33($A3D_DM, $m)
EndFunc

Func _A3D_Translate($dx, $dy, $dz)
	M44TranslateXYZR($A3D_DM, $dx, $dy, $dz)
EndFunc

Func _A3D_TranslateV($v)
	M44TranslateXYZR($A3D_DM, $v[0], $v[1], $v[2])
EndFunc

Func _A3D_Rotate($x, $y, $z)
	Local $_ = [[Cos($y) * Cos($z), -Cos($y) * Sin($z), Sin($y)], [Sin($x) * Sin($y) * Cos($z) + Cos($x) * Sin($z), -Sin($x) * Sin($y) * Sin($z) + Cos($x) * Cos($z), -Sin($x) * Cos($y)], [-Sin($y) * Cos($x) * Cos($z) + Sin($x) * Sin($z), Sin($y) * Cos($x) * Sin($z) + Sin($x) * Cos($z), Cos($x) * Cos($y)]]
	$A3D_DM = M44MulM33($A3D_DM, $_)
EndFunc

Func _A3D_RotateV($v)
	Return _A3D_Rotate($v[0], $v[1], $v[2])
EndFunc

